/*
 * Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.impact;

import eu.univento.commons.server.ServerType;
import eu.univento.core.Core;
import eu.univento.core.api.command.CommandFramework;
import eu.univento.core.api.server.ServerSettings;
import eu.univento.core.commands.PlayerCommands;
import eu.univento.impact.listeners.JoinQuit;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * @author joethei
 * @version 0.1
 */
public class Impact extends JavaPlugin{

    @Getter private static Impact instance;

    @Override
    public void onEnable() {
        instance = this;
        PluginManager pm = Bukkit.getPluginManager();
        pm.registerEvents(new JoinQuit(), this);

        CommandFramework commandFramework = Core.getCommandFramework();

        commandFramework.registerCommands(new PlayerCommands());

        ServerSettings.setServerType(ServerType.GAME_IMPACT);
        ServerSettings.setGameMode(GameMode.ADVENTURE);
    }

    @Override
    public void onDisable() {

    }
}